% Evaluate a polynomial and return 'values'

function values = basisfunc(data, parents)

linear      = true;
polynomial2 = false;
add3        = false;
polynomial3 = false;

if linear
   if nargin == 1
      n = data; % That is, the number of variables
      values = 1 + n;
      return
   end
   n = length(parents);
   N = size(data, 1);
   values = ones(N, n + 1);
   values(:, 1:n) = data(:, parents);
   return
end

if polynomial2
   degree = 2;
   if nargin == 1
      n = data;
      values = (degree + 1)^n;
      return
   end
   num_in = length(parents);
   n = (degree + 1)^num_in;
   N = size(data, 1);
   values = ones(N, n);
   for b = 1:n
       xp = dec2base(b - 1, degree + 1, num_in);
       values(:, b) = prod(data(:, parents) .^ repmat((xp - '0'), N, 1), 2);
   end
   return
end

if add3
   degree = 3;
   if nargin == 1
      n = data;
      values = degree * n + 1;
      return
   end
   num_in = length(parents);
   n = degree * num_in + 1;
   N = size(data, 1);
   values = ones(N, n);
   for b = 1:degree
       for p = 1:num_in
           values(:, (p - 1) * num_in + b) = data(:, parents(p)) .^ b;
       end
   end
   return
end

if polynomial3
   degree = 3;
   if nargin == 1
      n = data;
      values = (degree + 1)^n;
      return
   end
   num_in = length(parents);
   n = (degree + 1)^num_in;
   N = size(data, 1);
   values = ones(N, n);
   for b = 1:n
       xp = dec2base(b - 1, degree + 1, num_in);
       values(:, b) = prod(data(:, parents) .^ repmat((xp - '0'), N, 1), 2);
   end
   return
end

if nargin == 1
   n = data;
   values = (n + n * (n - 1) + n * (n - 1) * (n - 2) / 6) + (n * (n + 1) / 2) + n + 1;
   return
end

n = length(parents);
size_d = (n + n * (n - 1) + n * (n - 1) * (n - 2) / 6) + (n * (n + 1) / 2) + n + 1;
N = size(data, 1);
values = zeros(N, size_d);

pd = [data(:, parents) repmat(1, N, 1)];
idx = 0;

% 3 choices
for x1 = 1:n
    for x2 = x1:n
        for x3 = x2:n
            idx = idx + 1;
            values(:, idx) = pd(:, x1) .* pd(:, x2) .* pd(:, x3);
        end
    end
end

% 2 choices
for x1 = 1:n
    for x2 = x1:n
        idx = idx + 1;
        values(:, idx) = pd(:, x1) .* pd(:, x2);
    end
end

% 1 choice
for x1 = 1:n
    idx = idx + 1;
    values(:, idx) = pd(:, x1);
end

% 0 choices
idx = idx + 1;
values(:, idx) = repmat(1, N, 1);

end