% get_cv_matrix:
%
% Generate a f-fold cross-validation matrix for a dataset of N rows.

function cv = get_cv_matrix(N, f)

perm = randsample(N, N)';
cv = cell(f, 1);

avg_size  = floor(N / f);
last_size = N - (f - 1) * avg_size;
cv_size = avg_size * ones(f, 1); 
cv_size(f) = last_size;

acc = 0;
for ff = 1:f
    cv{ff} = perm((1 + acc):(acc + cv_size(ff)))';
    acc = acc + cv_size(ff);
end
