% get_x_estimate:
%
% Reads a logfile of latent variables generated by mcmc_gpsem_fspgp,
% then report the average over MCMC samples.

function x_estimate = get_x_estimate(file_name, num_latents, sample_size, skip)

file_id = fopen(file_name, 'r');
x_estimate = zeros(sample_size, num_latents);
num_lines = 0;
buffer = zeros(num_latents * sample_size, 1);

data_line = textscan(file_id, '%f', num_latents);
mcmc_count = 1;

while ~feof(file_id)
    % Read the next MCMC sample
    disp(sprintf('mcmc #%d', mcmc_count)); mcmc_count = mcmc_count + 1;
    buffer_pos = 1;
    for d = 1:sample_size        
        buffer(buffer_pos:(buffer_pos + num_latents - 1)) = data_line{1};
        buffer_pos = buffer_pos + num_latents;
        data_line = textscan(file_id, '%f', num_latents);
    end
    new_sample = reshape(buffer, sample_size, num_latents); % Notice peculiar format
        
    % Update estimate
    if skip < 0
       num_lines = num_lines + 1;
       x_estimate = x_estimate + new_sample;
    end
    
    skip = skip - 1;
end

fclose(file_id);
x_estimate = x_estimate / num_lines;
