% read_mcmc_means:
%
% Read predictions from file and return the mean. It requires knowing
% how many variables there are per line.

function sample_mean = read_mcmc_means(file_name, num_vars, skip)

file_id = fopen(file_name, 'r');
sum_vars = zeros(num_vars, 1);
num_lines = 0;

data_line = textscan(file_id, '%f', num_vars);
while ~feof(file_id)
    if skip < 0
       num_lines = num_lines + 1;
       sum_vars = sum_vars + data_line{1};    
    end
    data_line = textscan(file_id, '%f', num_vars);
    skip = skip - 1;
end

fclose(file_id);
sample_mean = sum_vars / num_lines;